import { BaseComponent } from './base';
import { FormGroup, AbstractControl, FormArray } from '@angular/forms';
import { Injector } from '@angular/core';
export declare abstract class FormBaseComponent<TModel> extends BaseComponent {
    form: FormGroup;
    private formBaseValidationService;
    constructor(formInjector: Injector);
    protected getValue(controlName: string, formGroup?: FormGroup): any;
    protected setValue(controlName: string, data: any, formGroup?: FormGroup): void;
    protected patchValue(value: Object, formGroup?: FormGroup): void;
    protected getControl(controlName: string, formGroup?: FormGroup): AbstractControl;
    private getFormValue;
    private setFormValue;
    private getFormControl;
    protected cloneFormGroup(copyForm: FormGroup, copyTo: FormGroup, clearAll?: boolean): void;
    fireFormControlValidation(control: AbstractControl): void;
    fireFormGroupValidation(formGroup?: FormGroup): void;
    fireFormArrayValidation(formArray: FormArray): void;
}
