import { AfterContentInit, EventEmitter, OnDestroy, OnInit, QueryList, TemplateRef } from '@angular/core';
import { GridCustomTemplate, INgxGridFilter, INgxGridResult } from 'ngx-primeng-grid';
import { DialogService } from 'primeng/dynamicdialog';
import { INgxCrudLayout, INgxCrudLayoutSettingManageActionConfig } from '../../_models/_crud-layout';
import { BaseComponent } from '../../../core/_base/base';
import { INgxFilter } from '../../../core/_interfaces/iresult';
import { IBreadcrumb } from '../../../ngx-wrapper-shared/models/breadcrumb';
import { ConfirmationService } from 'primeng/api';
export declare class NgxCrudGridComponent extends BaseComponent implements OnInit, AfterContentInit, OnDestroy {
    private dialog;
    private confirmDialog;
    templates: QueryList<GridCustomTemplate>;
    _layout: INgxCrudLayout;
    _loading: boolean;
    set layout(value: INgxCrudLayout);
    breadcrumbs: IBreadcrumb[];
    onReady: EventEmitter<INgxCrudLayout>;
    _customColumnTemplate: TemplateRef<any>;
    _dialogKey: string;
    _filter: INgxFilter<any>;
    _result: INgxGridResult<any>;
    constructor(dialog: DialogService, confirmDialog: ConfirmationService);
    ngOnInit(): void;
    ngAfterContentInit(): void;
    handleActionClick(action: INgxCrudLayoutSettingManageActionConfig): void;
    private getModalActionAction;
    private openManageDialog;
    handleFilterChanged(filter: INgxGridFilter): void;
    handleSearch(text: string): void;
    onActionEdit(row: any): void;
    onActionDelete(row: any): void;
    private invokeGridAction;
    private initFilter;
    private lodResult;
    ngOnDestroy(): void;
}
