import { INgxGridInstance, INgxGridColumn } from 'ngx-primeng-grid';
import { INgxPrimengForm } from 'ngx-primeng-form';
export interface INgxManageLayoutAction<T> {
    instance?: INgxGridInstance<T>;
    source: string;
}
export interface INgxManageLayoutApi {
    manage: string;
    delete: string;
    search: string;
    items: string;
    changeStatus: string;
    form: string;
    layout: string;
}
export interface INgxManageLayoutSetting {
    pageTitle: string;
    addOption: INgxManageLayoutSettingAddOption;
    pk: string;
    enableSearch: boolean;
    saveSearch: boolean;
    perPage: number;
    actionMode: string;
    defaultSortColumn: string;
    defaultSortOrder: number;
    layoutId: string;
}
export interface INgxManageLayoutSettingAddOption {
    enable: boolean;
    mode: string;
    link?: string;
    label: string;
    modalTitle?: string;
    modalWidth: string;
}
export interface INgxManageLayout {
    api: INgxManageLayoutApi;
    setting: INgxManageLayoutSetting;
    columns: INgxGridColumn[];
    form: INgxManageLayoutForm;
}
export interface INgxManageLayoutDialogData<T> {
    data?: any;
    layout?: INgxManageLayout;
    model: T;
}
export interface INgxManageLayoutForm {
    actions: INgxManageLayoutActionButton[];
    controls: INgxPrimengForm[];
    confirmations: INgxManageLayoutConfirmation[];
}
export interface INgxManageLayoutActionButton {
    key: string;
    name: string;
    styleClass: string;
    validate: boolean;
    resetControls?: string[];
}
export interface INgxManageLayoutConfirmation {
    key: string;
    heading: string;
    message: string;
}
